<id>
Last IP Mod
</id>

<version>
1.2
</version>

<mod info>
Tested on and coded for YaBB 2.0 Final.

**Overview:

This mod will add a column on your Memberlists (both regular and admin) showing each user's IP address when they last logged into the board.  This mod will also show your user's last IP in their user profile if you so desire.

**Please read the "readme.txt" file for more extensive information.**

**Install notes:  

You cannot have the Hidden User mod installed and then try to install the Last IP mod (or visa-versa) as portions of both mods modify the same parts of certain files.  Please use the Last IP for Hidden User addon if you wish to use both mods (install the Hidden User Mod first then apply the addon).  

1) Uninstall any previous version of this mod.
2) Run new version of mod appropriate for your board's version (2.0 Final or 2.1)
3) Upload last_ip.lng files to your Languages/English directory.
4) Upload the last_ip.pl file into your Admin directory (default permisssions will work). 
5) Activate all or parts of mod in Admin Center under Installed Mods.

Switches include:
--Enable/diasable Last IP entirely.
--Allow/disallow gmods to view last IPs.
--Show user's last IP in their profile.

Modifies the following files:
-AdminIndex.pl
-YaBB.pl
-Admin/AdminSubList.pl
-Admin/ModList.pl
-Admin/ViewMembers.pl
-Sources/LogInOut.pl
-Sources/Memberlist.pl
-Sources/Profile.pl
-Sources/Subs.pl
-Sources/System.pl
-Adds a variable valled "last_ip" in each user's .vars file.
-Admin Center settings are stored in the Variables directory called "last_ip.txt".

**Many thanks to JetLi for providing a German translation of this mod!

If you have any problems, comments, or bug reports, send them to: webmaster@eyeontoccoa.com.

Version History:
## 1.0 ##
- Original Release

## 1.1 ##
-- Adjusted code to work with Yabb 2.0 Final

## 1.2 ##
-- Added "Last IP" to user profile
</mod info>

<author>
Brian Longo
</author>

<homepage>
http://www.eyeontoccoa.com/mods/
</homepage>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
$last_ip = "last_ip|Last IP Mod|Last IP Mod|";
push (@boardmod_mods, "$last_ip");
</add before>

<edit file>
YaBB.pl
</edit file>

<search for>
&banning;     # Check for banned people
&WriteLog;    # Write to the log
&LoadIMs;     # Load IM's
</search for>

<add before>
## Start Last IP Mod ##
if (-e("$vardir/last_ip.txt"))  {
    require "$vardir/last_ip.txt";
}
## End Last IP Mod ##
</add before>

<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
'mailmultimembers',"Admin.pl&DeleteMultiMembers",
'mailing2',"MailMembers.pl&Mailing2",
'mailing3',"MailMembers.pl&Mailing3",
</search for>

<add before>
'last_ip',"last_ip.pl&last_ip_set",  ## Last IP Mod ##
'last_ip2',"last_ip.pl&last_ip_set_2",  ## Last IP Mod ##
</add before>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$last_ip_mod = "Last IP Mod|Brian Longo|View the last IP address of your users.|1.2|12/12/2005";
	push (@installed_mods, "$last_ip_mod");
</add before>

<edit file>
Admin/ViewMembers.pl
</edit file>

<search for>
LoadLanguage("Main");
</search for>

<add after>
## Start Last IP Mod part 1 - load language file ##
LoadLanguage("last_ip");
## End Last IP Mod part 1 ##

</add after>

<search for>
<form name="adv_memberview" action="$adminurl?action=deletemultimembers;$sortmode$sortorder" method="POST" style="display: inline" onSubmit="return submitproc()">
<input type="hidden" name="button" value="0" />
<table border="0" width="100%" cellspacing="1" cellpadding="3" class="bordercolor">
<tr>
	<td class="catbg" width="19%" align="center"><b>$ml_txt{'35'}</b></td>
	<td class="catbg" width="19%" align="center"><b>$ml_txt{'87'}</b></td>
	<td class="catbg" width="19%" align="center" colspan="2"><b>$ml_txt{'21'}</b></td>
	<td class="catbg" width="19%" align="center"><b>$ml_txt{'234'}</b></td>
	<td class="catbg" width="19%" align="center" colspan="3"><b>$amv_txt{'4'}</b><br /><span class="small" style="float: left; text-align: center; width: 34%;">$amv_txt{'5'}</span><span class="small" style="float: left; text-align: center; width: 33%;">$amv_txt{'6'}</span><span class="small" style="float: left; text-align: center; width: 33%;">$amv_txt{'7'}</span></td>
	<td class="catbg" width="5%" align="center"><b>$admintxt{'38'}</b></td>
</tr>
~;

if ($LetterLinks ne "") {
	$TableHeader .= qq~<tr>
		<td class="catbg" colspan="9"><b>$LetterLinks</b></td>
	</tr>
	~;
}
</search for>

<replace>
<!-- ## Start Last IP Mod part 2 - add "Last IP" column to table of members ## -->
<form name="adv_memberview" action="$adminurl?action=deletemultimembers;$sortmode$sortorder" method="POST" style="display: inline" onSubmit="return submitproc()">
<input type="hidden" name="button" value="0" />
<table border="0" width="100%" cellspacing="1" cellpadding="3" class="bordercolor">
<tr>
	<td class="catbg" width="24%" align="center"><b>$ml_txt{'35'}</b></td>
	<td class="catbg" width="12%" align="center"><b>$ml_txt{'87'}</b></td>
	<td class="catbg" width="17%" align="center" colspan="2"><b>$ml_txt{'21'}</b></td>
	<td class="catbg" width="17%" align="center"><b>$ml_txt{'234'}</b></td>
	<td class="catbg" width="17%" align="center" colspan="3"><b>$amv_txt{'4'}</b><br /><span class="small" style="float: left; text-align: center; width: 34%;">$amv_txt{'5'}</span><span class="small" style="float: left; text-align: center; width: 33%;">$amv_txt{'6'}</span><span class="small" style="float: left; text-align: center; width: 33%;">$amv_txt{'7'}</span></td>
	<td class="catbg" width="5%" align="center"><b>$admintxt{'38'}</b></td>~;
	if ($iamadmin || ($iamgmod && $allow_gmod eq 1)){
	$TableHeader .= qq~<td class="catbg" width="13%" align="center"><b>$ip_txt{'1'}</b></td>~;}
	else {$TableHeader .= qq~<!-- Gmod access disabled -->~;} 
</tr>
~;

if($LetterLinks ne "") {
	$TableHeader .= qq~<tr>
		<td class="catbg" colspan="10"><b>$LetterLinks</b></td>
	</tr>
	~;
}
## End Last IP Mod part 2 ##
</replace>

<search for>
		$yymain .= qq~
		<td class="windowbg" width="19%">$memberinfo</td>
		<td class="windowbg2" width="5%" align="center">${$uid.$user}{'postcount'}</td>
		<td class="windowbg" width="14%">$Bar</td>
		<td class="windowbg" width="19%" >${$uid.$user}{'regdate'}&nbsp;</td>
		<td class="windowbg2" width="7%" align="center">$userlastonline</td>
		<td class="windowbg2" width="6%" align="center">$userlastpost</td>
		<td class="windowbg2" width="6%" align="center">$userlastim</td>
		<td class="windowbg" width="5%" align="center">$addel</td>
	</tr>~;
</search for>

<replace>
## Start Last IP Mod part 3 - add user IP data to table ##
		$yymain .= qq~
		<td class="windowbg" width="24%">$memberinfo</td>
		<td class="windowbg2" width="5%" align="center">${$uid.$user}{'postcount'}</td>
		<td class="windowbg" width="12%">$Bar</td>
		<td class="windowbg" width="10%" align="center">${$uid.$user}{'regdate'}&nbsp;</td>
		<td class="windowbg2" width="6%" align="center">$userlastonline</td>
		<td class="windowbg2" width="6%" align="center">$userlastpost</td>
		<td class="windowbg2" width="6%" align="center">$userlastim</td>
		<td class="windowbg" width="5%" align="center">$addel</td>~;
		if ($iamadmin || ($iamgmod && $allow_gmod eq 1)){
		$yymain .= qq~<td class="windowbg2" width="4%" align="center">${$uid.$user}{'last_ip'}</td>~;}
		else {$yymain .= qq~<!-- Gmod access disabled -->~;} 
	</tr>~;
## End Last IP Mod part 3##
</replace>

<edit file>
Sources/LogInOut.pl
</edit file>

<search for>
	$iamguest = $username eq 'Guest' ? 1 : 0;
	if ($FORM{'cookielength'} == 1) { $ck{'len'} = 'Sunday, 17-Jan-2038 00:00:00 GMT'; }
	else { $ck{'len'} = "\+$FORM{'cookielength'}m"; }
	$password = &encode_password("$FORM{'passwrd'}");
	${$uid.$username}{'session'} = &encode_password($user_ip);
	chomp ${$uid.$username}{'session'};
	&UserAccount($username, "update", "lastonline");
</search for>

<add after>
	&UserAccount($name,"ip","last_ip"); ## Last IP Mod ##
</add after>

<search for>
sub Logout {
	# Write log
	fopen(LOG, "$vardir/log.txt");
	my @entries = <LOG>;
	fclose(LOG);
	fopen(LOG, ">$vardir/log.txt", 1);
	$field = $username;
	foreach $curentry (@entries) {
		$curentry =~ s/\n//g;
		($name, $value) = split(/\|/, $curentry);
		if ($name ne $field) { print LOG "$curentry\n"; }
	}
	fclose(LOG);
	if ($action ne "profile2") { &UserAccount($username, "update", "lastonline"); }
</search for>

<replace>
sub Logout {
	# Write log
	fopen(LOG, "$vardir/log.txt");
	my @entries = <LOG>;
	fclose(LOG);
	fopen(LOG, ">$vardir/log.txt", 1);
	$field = $username;
	foreach $curentry (@entries) {
	        $curentry =~ s/\n//g;
     		($name, $value) = split(/\|/, $curentry);
	        if($name ne $field) { print LOG "$curentry\n"; }
	}
	fclose(LOG);
	if ($action ne "profile2") {&UserAccount($username,"update","lastonline" );
	&UserAccount($name,"ip","last_ip"); ## Last IP Mod ##
	}
</replace>

<edit file>
Sources/Memberlist.pl
</edit file>

<search for>
$memberlistplver = 'YaBB 2.0 $Revision: 1.48 $';
</search for>

<add after>
## Start Last IP Mod part 1 - load language file ##
LoadLanguage("last_ip");
## End Last IP Mod part 1 ##
</add after>

<search for>
$TableHeader .= qq(
<tr>
	<td $selUser onclick="location.href='$scripturl?action=ml;sort=username';" width="23%" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><b>$ml_txt{'35'}</b></td>
	<td class="catbg" width="4%" align="center"><img src="$imagesdir/email.gif" border="0" alt="$ml_txt{'307'}" /></td>
	<td class="catbg" width="4%" align="center"><img src="$imagesdir/www.gif" border="0" alt="$ml_txt{'96'}" /></td>
	<td $selPos onclick="location.href='$scripturl?action=ml;sort=position';" width="23%" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><b>$ml_txt{'87'}</b></td>
	<td $selPost onclick="location.href='$scripturl?action=ml;sort=posts';" width="23%" colspan="2" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><b>$ml_txt{'21'}</b></td>
	<td $selReg onclick="location.href='$scripturl?action=ml;sort=regdate';" width="23%" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><b>$ml_txt{'234'}</b></td>
</tr>
);

if ($LetterLinks ne "") {
	$TableHeader .= qq(<tr>
		<td class="catbg" colspan="7"><span class="small">$LetterLinks</span></td>
	</tr>
	);
}
</search for>

<replace>
## Start Last IP Mod part 2 - show/hide Last IP column depending on user ##
if(($iamadmin && $show_ip eq 1) || ($iamgmod && $show_ip eq 1 && $allow_gmod eq 1)){
$TableHeader .= qq(
<tr>
	<td $selUser onclick="location.href='$scripturl?action=ml;sort=username';" width="20%" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><b>$ml_txt{'35'}</b></td>
	<td class="catbg" width="4%" align="center"><img src="$imagesdir/email.gif" border="0" alt="$ml_txt{'307'}" /></td>
	<td class="catbg" width="4%" align="center"><img src="$imagesdir/www.gif" border="0" alt="$ml_txt{'96'}" /></td>
	<td $selPos onclick="location.href='$scripturl?action=ml;sort=position';" width="20%" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><b>$ml_txt{'87'}</b></td>
	<td $selPost onclick="location.href='$scripturl?action=ml;sort=posts';" width="20%" colspan="2" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><b>$ml_txt{'21'}</b></td>
	<td $selReg onclick="location.href='$scripturl?action=ml;sort=regdate';" width="20%" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><b>$ml_txt{'234'}</b></td>
    <td class="windowbg2" width="12%" align="center"><b>$ip_txt{'1'}</b></td> <!-- ## Last IP Mod ## -->
</tr>
);
}

else{
$TableHeader .= qq(
<tr>
	<td $selUser onclick="location.href='$scripturl?action=ml;sort=username';" width="23%" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><b>$ml_txt{'35'}</b></td>
	<td class="catbg" width="4%" align="center"><img src="$imagesdir/email.gif" border="0" alt="$ml_txt{'307'}" /></td>
	<td class="catbg" width="4%" align="center"><img src="$imagesdir/www.gif" border="0" alt="$ml_txt{'96'}" /></td>
	<td $selPos onclick="location.href='$scripturl?action=ml;sort=position';" width="23%" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><b>$ml_txt{'87'}</b></td>
	<td $selPost onclick="location.href='$scripturl?action=ml;sort=posts';" width="23%" colspan="2" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><b>$ml_txt{'21'}</b></td>
	<td $selReg onclick="location.href='$scripturl?action=ml;sort=regdate';" width="23%" align="center" style="border: 1px; border-style: outset; cursor: pointer;"><b>$ml_txt{'234'}</b></td>
</tr>
);	
}

if($LetterLinks ne "" && ($iamadmin || $iamgmod) && $show_ip eq 1) {
	$TableHeader .= qq(<tr>
		<td class="catbg" colspan="8"><span class="small">$LetterLinks</span></td>
	</tr>
	);
}

elsif($LetterLinks ne "") {
	$TableHeader .= qq(<tr>
		<td class="catbg" colspan="7"><span class="small">$LetterLinks</span></td>
	</tr>
	);
}

## End Last IP Mod Part 2 ##
</replace>

<search for>
		if ($letter) { $yymain .= qq~<tr><td class="windowbg" colspan="7" align="center"><br /><b>$ml_txt{'760'}</b><br /><br /></td></tr>~; }
</search for>

<replace>
## Start Last IP Mod part 3 - add Last IP column ##
    if(($iamadmin && $show_ip eq 1) || ($iamgmod && $show_ip eq 1 && $allow_gmod eq 1)){
	   if($letter) {$yymain .= qq~<tr><td class="windowbg" colspan="8" align="center"><br /><b>$ml_txt{'760'}</b><br /><br /></td></tr>~;}
	   elsif($letter) {$yymain .= qq~<tr><td class="windowbg" colspan="7" align="center"><br /><b>$ml_txt{'760'}</b><br /><br /></td></tr>~;}
	}
## End Last IP Mod part 3 ##
</replace>

<search for>
		$yymain .= qq~
		<td align="center" class="windowbg2">$wwwshow</td>
		<td class="windowbg">$memberinfo{$user}&nbsp;</td>
		<td class="windowbg2" width="5%" align="center">${$uid.$user}{'postcount'}&nbsp;</td>
		<td class="windowbg" width="18%">$Bar</td>
		<td class="windowbg">${$uid.$user}{'regdate'}&nbsp;</td>
</search for>

<add after>
<!-- #Start Last IP Mod part 4 - add Last IP data to member list ## -->
	 	~;
    if(($iamadmin && $show_ip eq 1) || ($iamgmod && $show_ip eq 1 && $allow_gmod eq 1)){
		$yymain .= qq~
		<td align="center" class="windowbg2">${$uid.$user}{'last_ip'}&nbsp;</td>
		~;
	}
	else {$yymain .= qq~<!-- Last IP Mod Off -->~;}
		$yymain .= qq~
<!-- ## End Last IP Mod part 4 ## -->
</add after>

<search for>
		<tr>
		<td class="catbg" colspan="7" width="100%" align="left" valign="middle">
</search for>

<replace>
<!--## Start Last IP Mod part 5 - span header to include Last IP column ##-->
	<tr>~;
    if(($iamadmin && $show_ip eq 1) || ($iamgmod && $show_ip eq 1 && $allow_gmod eq 1)){
		$yymain .= qq~
		<td class="catbg" colspan="8" width="100%" align="left" valign="middle">
		~;
	}
	else {
		$yymain .= qq~
		<td class="catbg" colspan="7" width="100%" align="left" valign="middle">
		~;
	}
     $yymain .= qq~
<!--## End Last IP Mod part 5 ##-->
</replace>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
		<div style="float: left; width: 30%; padding-top: 5px;  padding-bottom: 5px;">
		<b>$profile_amv_txt{'11'}: </b>
		</div>
		<div style="float: left; width: 70%; padding-top: 5px;  padding-bottom: 5px;">
		$userlastim
		</div>
	</td>
	</tr>
~;
</search for>

<replace>
		<div style="float: left; width: 30%; padding-top: 5px;  padding-bottom: 5px;">
		<b>$profile_amv_txt{'11'}: </b>
		</div>
		<div style="float: left; width: 70%; padding-top: 5px;  padding-bottom: 5px;">
		$userlastim
		</div>~;
## Start Last IP Mod - add user's last IP to profile ##
		if($show_profile_ip eq 1 && ($iamadmin && $show_ip eq 1) || ($iamgmod && $show_ip eq 1 && $allow_gmod eq 1)){
	       $userlastip=${$uid.$user}{'last_ip'};
		   LoadLanguage("last_ip");
		   $yymain .= qq~
		   <div style="float: left; width: 30%; padding-top: 5px;  padding-bottom: 5px;">
		   <b>$ip_txt{'1'}: </b>
		   </div>
		   <div style="float: left; width: 70%; padding-top: 5px;  padding-bottom: 5px;">
		   $userlastip
		   </div>~;
		}
		$yymain .= qq~
<!--## End Last IP Mod ##-->
	</td>
	</tr>
~;
</replace>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
		# This check needs to be present to prevent thrashing of the user.vars file
		if ($result > ($OnlineLogTime * 60)) {
			if (!${$uid.$name}{'password'}) { &LoadUser($name); }
			&UserAccount($name, "update", "lastonline");
		}
	}
	fclose(LOG);
</search for>

<replace>
## Start Last IP Mod - add/replace current ip in user's .vars file ##
	if (!${$uid.$username}{'password'}){&LoadUser($username);}
	my $ip_old = ${$uid.$username}{'last_ip'};
	my $ip_new = $user_ip;
	   if($ip_new ne $ip_old) {
	       ${$uid.$username}{'last_ip'} = $ip_new;
		   &UserAccount($username,"ip","last_ip");
	   }
	}
# This check needs to be present to prevent thrashing of the user.vars file
		if($result > ($OnlineLogTime*60)) { 
			if(!${$uid.$name}{'password'}){ &LoadUser($name);}
			&UserAccount($name,"update","lastonline");
			&UserAccount($name,"update_ip","last_ip");
		}
	fclose(LOG);
## End Last IP Mod ##
</replace>

<edit file>
Sources/System.pl
</edit file>

<search for>
	my @tags = qw(password realname email regdate webtitle weburl signature postcount position addgroups icq aim yim gender usertext userpic regtime location bday timeselect timeoffset timeformat hidemail msn gtalk template language lastonline lastpost lastim im_ignorelist im_notify im_popup im_imspop cathide postlayout session sesquest sesanswer favorites dsttimeoffset pageindex);
</search for>

<add after>
	push(@tags,qw(last_ip)); ## Last IP Mod ##
</add after>

<search for>
	if ($action eq "update") {
		foreach $label (@labels) {
			chomp $label;
			${$uid.$user}{$label} = $date;
		}
		$userext = "vars";
	}
</search for>

<add after>
## Start Last IP Mod ##
	if ($action eq "ip") {
		foreach $label(@labels){
			chomp $label;
			${$uid.$user}{$label}=$user_ip;
		}
		$userext = "vars";
	}
## End Last IP Mod ##
</add after>